//Un niveau standard : contient des liens et des noeuds !
package
{
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.display.Shape;
	import flash.events.*;
	import flash.filters.BlurFilter//Tailleter

	public class Niveau extends Sprite
	{
		public var All_Noeuds:Array;
		public var All_Liens:Array;

		public var NumeroNiveau:int=0;

		public var TailleActuelle:Number=1;//Le niveau de Taille du Fond actuel
		private var TailleFinale:int=1;//Le niveau final de Taille demand pour Fond.

		private var Gonflement:Number=0;

		private const RAYON_NOEUDS:int=200; //Le rayon du cercle fait par les noeuds

		public function Niveau(Liens:Array,Largeur:int=0,Hauteur:int=0)
		{
			//Trouver le nombre de noeuds :
			var NbNoeuds:int=0;
			var Lien:Array;
			var Arete:Arc

			for each(Lien in Liens)
			{
				NbNoeuds=Math.max(NbNoeuds,Lien[0],Lien[1]);
			}

			All_Noeuds = new Array();
			All_Liens = new Array();
			NbNoeuds++;//Petite astuce trigonomtrique...
			for(var i:int=0;i<NbNoeuds;i++)//Remarquer qu'on fait < et pas <=, pour contourner l'astuce
			{//Ajouter le noeud
				All_Noeuds.push(new Noeud(this,
				Largeur/2 + Math.cos(2*Math.PI*(i/NbNoeuds))*RAYON_NOEUDS,
				Hauteur/2 + Math.sin(2*Math.PI*(i/NbNoeuds))*RAYON_NOEUDS
				,All_Liens,NbNoeuds));
			}

			for each(Lien in Liens)
			{
				Arete=new Arc(this,All_Noeuds[Lien[0]],All_Noeuds[Lien[1]],All_Liens);
				All_Noeuds[Lien[0]].AjouterLien(Arete);
				All_Noeuds[Lien[1]].AjouterLien(Arete);
				All_Liens.push(Arete);
			}
			for each(Arete in All_Liens)
			{//Tous les liens sont cres, reste  updater :
				Arete.UpdateCollision(false);
			}

			this.graphics.beginFill(0xFFFFFF);
			this.graphics.drawRect(0, 0, Largeur, Hauteur);
		}

		public function set Taille(value:int):void
		{
 			TailleFinale=value;
 			this.addEventListener(Event.ENTER_FRAME,GererTaille);//Cette ligne fait crasher en mode debugger.
		}

		private function GererTaille(e:Event):void
		{//Tailleter le niveau en arrire plan
			if(TailleActuelle!=TailleFinale && TailleActuelle>=0 && TailleActuelle<=1)
			{
				if(TailleActuelle<TailleFinale)
					TailleActuelle+=.05;
				else
					TailleActuelle-=.02;
				this.scaleX=this.scaleY=TailleActuelle;
			}
			else
			{
				this.TailleActuelle=this.scaleX=this.scaleY=TailleFinale;
				this.removeEventListener(Event.ENTER_FRAME,GererTaille);
			}
		}
	}
}