//Code original par Neamar. Rutilisation libre.
//neamar@neamar.fr

//Ligne de commande pour compiler :
//(aprs s'tre plac dans le bon dossier, cf. http://neamar.fr/Res/Compiler_AS3/)
//
//bash mxmlc Sources/B-graphe/graphe.as -default-size 640 480 -compiler.strict

//Life begins when you can spend your spare time programming instead of
//watching television.

package
{
	import flash.display.Sprite;//La classe de base, fort utile !
	import flash.events.*;//Chargons tous les venements ce sera plus simple :)
	import flash.geom.Point;//Un point tout ce qu'il y a de plus normal : dfini par (x,y).
	import flash.text.TextField;//Champ de texte. Classe assez vaste, utilise uniquement pour l'affichage de texte ici

	import flash.filters.BitmapFilter;//Classe globale pour les filtres
	import flash.filters.GlowFilter;//Filtre d'irridescence (clairage, le plus utilis)
	import flash.filters.BlurFilter//Flouter

	import flash.net.SharedObject;//Sauvegarde locale


	[SWF(width = "640", height = "480", frameRate = 25)];//Quelques paramtres pour la compilation. Ils sont cependant redfinis dans la ligne de commande.

	public class Bgraphe extends Sprite
	{
		public var Fond:Niveau=new Niveau(new Array());//Fond est un Sprite Niveau, qui contient le niveau en cours.

		public const VERSION:String="Alpha";//La version

		public var SAVE_LOCAL:SharedObject;//L'enregistrement du niveau en cours, et des niveaux unlocks.
		public var SESSION:Object;//Un raccourci vers SharedObject.datas

		public var NumeroNiveauActuel:int=0;
		public var NumeroNiveauUnlockes:int;

		function Bgraphe():void
		{
// 			Les constantes primitives utilises tout au long du Flash
			const FlashWidth:int = 640;
			const FlashHeight:int = 480;

//			Rcuperer les donnes locales
			SAVE_LOCAL = SharedObject.getLocal("BGraphe");
			SESSION = SAVE_LOCAL.data;

// 			SESSION.NumeroNiveauUnlockes=SESSION.NumeroNiveauActuel=11;
// 			SESSION.NumeroNiveauActuel=SESSION.NumeroNiveauUnlockes=null;

			if(SESSION.NumeroNiveauActuel==null)
				SESSION.NumeroNiveauActuel=SESSION.NumeroNiveauUnlockes=NumeroNiveauActuel;//On ne met pas  0 afin de permettre des tests : lors du dbuggage, il suffit de changer une variable pour passer  un niveau.

			NumeroNiveauUnlockes=SESSION.NumeroNiveauUnlockes;//Recharger les dernires valeurs
			NumeroNiveauActuel=NumeroNiveauUnlockes;//Commencer au dernier niveau

   			include "../Trace.as";
 			include "ChangementsNiveaux.as";//Pendant le niveau, teste si il est fini. Prpare le passage  un nouveau niveau.
 			include "ChargementNiveaux.as";//La liste des niveaux
 			include "Message.as";//La boite de message. Montre un message via la mthode ShowMessage(message:String)

			Fond.scaleX=0;//Animation
			LancerNouveauNiveau();


			////////////////////////////////
			//Les lments inclassables
			////////////////////////////////
			function SourisIN(e:Event):void
			{//Fonction Utilise sur tous les sprites de type bouton : ajoute un filtre au Sprite afin de l'illuminer
				AppliquerFiltre(e.currentTarget)
			}
			function SourisOUT(e:Event):void
			{//Fonction Utilise sur tous les sprites de type bouton : retire les filtres du Sprite
				e.currentTarget.filters=new Array();
			}
			function AppliquerFiltre(Element:Sprite,Couleur:uint=0x000000):void
			{//Ajoute un filtre de rayonnement  l'objet spcifi
				var FiltreHover:BitmapFilter = new GlowFilter(Couleur, 0.8,16,16,3,1,false,false);
				var ListeFiltres:Array = new Array();
				ListeFiltres.push(FiltreHover);
				Element.filters=ListeFiltres;
			}
			function ResetAll(e:Event):void
			{
				NumeroNiveauActuel=NumeroNiveauUnlockes=SESSION.NumeroNiveauActuel=SESSION.NumeroNiveauUnlockes=0;
				UpdaterBoite();
			}
		}
	}
}
